/*	
	TuttoCitt 0.6
	
	Author: Paolo Grifantini 09/08/2011
	Contact: pagri@tele2.it
	
	This work is licensed under a Creative Commons License
	http://creativecommons.org/licenses/by-nc-sa/2.0/
	
	Attribution-NonCommercial-NoDerivative 2.0
	
	You are free:
	* to copy, distribute and display the work
	
	Under the following conditions:
	* Attribution. You must give the original author credit.
	* Noncommercial. You may not use this work for commercial purposes.
	* No derivative works allowed.
	
	* For any reuse or distribution, you must make clear to others the license terms of this work.
	* Any of these conditions can be waived if you get permission from the copyright holder.
	
*/

var newShow = { show : function(element) { $(element).style.display = 'block'; return element; } }
Element.addMethods(newShow);

var current_version = "0.6";
var there_is_a_new_version = false;

window.onload = init;

function init(){
	localize_strings();
	
	CreateButton('button', { text: getLocalizedString('cerca'), onclick: 'getMappa', rightImageWidth: 5, leftImageWidth: 5 });
	
	setTimeout("version_check();", 20*1000);
}

function localize_strings()
{
	document.getElementById("MappaSelect0").innerHTML = getLocalizedString('linguetta_mappa');
	document.getElementById("MappaSelect0").alt = getLocalizedString('title_tooltip_on');
	document.getElementById("MappaSelect0").title = getLocalizedString('title_tooltip_on');
	
	document.getElementById("nomeComuneLabel").innerHTML = getLocalizedString('nomeComuneLabel');
	document.getElementById("addressLabel").innerHTML = getLocalizedString('addressLabel');
}

var mappaVis='';
var percorsoVis='';

function resize_on_finish(obj){
  window.resizeTo(239,40);
}

function showDiv(divName){
	// prima nascondo gli altri
	
	if (divName=='mappa'){
	
		if (mappaVis){
			mappaVis='';
			document.getElementById("MappaSelect0").style.color = 'brown';
			
			//document.getElementById('riMappa').style.display = 'none';
			Effect.BlindUp('riMappa',{ duration: 0.2, afterFinish: resize_on_finish});
			
			document.getElementById("MappaSelect0").alt = getLocalizedString('title_tooltip_on');
			document.getElementById("MappaSelect0").title = getLocalizedString('title_tooltip_on');
			
			//window.resizeTo(239,40);
		}
		else {
			mappaVis=1;
			document.getElementById("MappaSelect0").style.color = 'black';
			
			document.getElementById("MappaSelect0").alt = getLocalizedString('title_tooltip_off');
			document.getElementById("MappaSelect0").title = getLocalizedString('title_tooltip_off');
			
			//prima nascondi le altre
			percorsoVis='';
			//document.getElementById("MappaSelect1").style.color = 'brown';
			document.getElementById('riPercorso').style.display = 'none';
			//document.getElementById("MappaSelect1").alt = 'Cerca un percorso da... a...';
			//document.getElementById("MappaSelect1").title = 'Cerca un percorso da... a...';
			
			//resetta campi
			
			document.getElementById('nomeComune').value = '';
			document.getElementById('nomeVia').value = '';
			document.getElementById('numeroCivico').value = '';
			
			document.getElementById('nomeComuneLabel').style.color = 'black';
			
			//poi mostra
			window.resizeTo(239,200);
			//document.getElementById('riMappa').style.display = 'block';
			Effect.BlindDown('riMappa',{ duration: 0.2 });
			
			doneDiv = document.getElementById('done');
			
		}
	}
	else{
		if (percorsoVis){
			percorsoVis='';
			document.getElementById("MappaSelect1").style.color = 'brown';
			
			document.getElementById('riPercorso').style.display = 'none';
			
			document.getElementById("MappaSelect1").alt = 'Cerca un percorso da... a...';
			document.getElementById("MappaSelect1").title = 'Cerca un percorso da... a...';
			
			window.resizeTo(239,40);
		}
		else {
			percorsoVis=1;
			document.getElementById("MappaSelect1").style.color = 'black';
			
			document.getElementById("MappaSelect1").alt = 'Nascondi il pannello di ricerca';
			document.getElementById("MappaSelect1").title = 'Nascondi il pannello di ricerca';
			
			//prima nascondi le altre
			mappaVis='';
			document.getElementById("MappaSelect0").style.color = 'brown';
			document.getElementById('riMappa').style.display = 'none';
			document.getElementById("MappaSelect0").alt = 'Cerca una mappa';
			document.getElementById("MappaSelect0").title = 'Cerca una mappa';
			
			//resetta campi
			
			document.getElementById('nomeComunePartenza').value = '';
			document.getElementById('nomeViaPartenza').value = '';
			document.getElementById('numeroCivicoPartenza').value = '';
			
			document.getElementById('nomeComunePartenzaLabel').style.color = 'black';
			
			//resetta campi
			
			document.getElementById('nomeComuneArrivo').value = '';
			document.getElementById('nomeViaArrivo').value = '';
			document.getElementById('numeroCivicoArrivo').value = '';
			
			document.getElementById('nomeComuneArrivoLabel').style.color = 'black';
			
			//poi mostra
			window.resizeTo(239,300);
			document.getElementById('riPercorso').style.display = 'block';
		}
	}
					
}

function getMappa(){
	searchComune=document.getElementById('nomeComune').value;
	
	searchComuneSenzaSpazi = searchComune.replace(/\s+/g," ");
	
	if ( (searchComuneSenzaSpazi == '') || (searchComuneSenzaSpazi == ' ') ){
		document.getElementById('nomeComuneLabel').style.color = 'red';
				
		return;
	}
	else {document.getElementById('nomeComuneLabel').style.color = 'black';}
	
	searchVia=document.getElementById('nomeVia').value;
	searchCivico=document.getElementById('numeroCivico').value;
	
	//searchComune = searchComune.replace(/[\s]+/g,'%20');
	//searchVia = searchVia.replace(/[\s]+/g,'%20');
	searchCivico = searchCivico.replace(/[\s]+/g,'%20');
	
	
	widget.openURL("http://www.tuttocitta.it/tcol/mappe/"+encodeURI(searchComune)+"?dv=&ind="+encodeURI(searchVia)+"+"+searchCivico);
}



function getPercorso(){
		
		toReturn = '';
	
		searchComune=document.getElementById('nomeComunePartenza').value;
		searchComuneArrivo=document.getElementById('nomeComuneArrivo').value;
		searchComuneSenzaSpazi = searchComune.replace(/\s+/g," ");
		searchComuneArrivoSenzaSpazi = searchComuneArrivo.replace(/\s+/g," ");
		
		if ( (searchComuneSenzaSpazi == '') || (searchComuneSenzaSpazi == ' ') ){
			document.getElementById('nomeComunePartenzaLabel').style.color = 'red';
					
			toReturn = 1;
		}
		else {document.getElementById('nomeComunePartenzaLabel').style.color = 'black';}
		
		if ( (searchComuneArrivoSenzaSpazi == '') || (searchComuneArrivoSenzaSpazi == ' ') ){
			document.getElementById('nomeComuneArrivoLabel').style.color = 'red';
					
			toReturn = 1;
		}
		else {document.getElementById('nomeComuneArrivoLabel').style.color = 'black';}
		
		if (toReturn) {return;}
		
		
		searchVia=document.getElementById('nomeViaPartenza').value;
		searchCivico=document.getElementById('numeroCivicoPartenza').value;
		
		searchComune = searchComune.replace(/[\s]+/g,'+');
		searchVia = searchVia.replace(/[\s]+/g,'+');
		searchCivico = searchCivico.replace(/[\s]+/g,'+');


		searchViaArrivo=document.getElementById('nomeViaArrivo').value;
		searchCivicoArrivo=document.getElementById('numeroCivicoArrivo').value;
		
		searchComuneArrivo = searchComuneArrivo.replace(/[\s]+/g,'+');
		searchViaArrivo = searchViaArrivo.replace(/[\s]+/g,'+');
		searchCivicoArrivo = searchCivicoArrivo.replace(/[\s]+/g,'+');

		widget.openURL("http://www.tuttocitta.it/tcol/mappe/"+searchComune+"?dv=&ind="+searchVia+"+"+searchCivico+"&com2="+searchComuneArrivo+"&to2="+searchViaArrivo+"&civ2="+searchCivicoArrivo);
		
}

//************ version check **************************************

function goToDownloadPage()
{
	// vai al sito
	widget.openURL("http://www.palple.net/widgets/tuttocitta/TuttoCitta.zip");
}

var version_req_stop_timeout = false;
var version_req_timeout = false;

function loadVersionPage(url)
{
	if (window.XMLHttpRequest) {
		version_req = new XMLHttpRequest();
		version_req.onreadystatechange = parseVersionPage;
		version_req.overrideMimeType("text/xml");
		version_req.setRequestHeader("Cache-Control", "no-cache")
		version_req.open("GET", url, true);
		version_req.send(null);
		
		version_req_stop_timeout = false;
		version_req_timeout = false;
		setTimeout("version_req_send_timeout();",5000);
	}
}

function version_req_send_timeout()
{
	if (version_req_stop_timeout){return;}
	version_req_timeout = true;
}

function isGreaterVersion(release1, release2)
{
	// faccio uno split per il '.' e poi verifico valore per valore
	release1_numbers = release1.split('.');
	release2_numbers = release2.split('.');
	
	release1_value = 0;
	release2_value = 0;
	
	// risolvo matematicamente che  pi elegante...
	
	for (var i=0;i<release1_numbers.length;i++){
		release1_value += release1_numbers[i]*(Math.pow(10,-i*3));
	}
	
	for (var i=0;i<release2_numbers.length;i++){
		release2_value += release2_numbers[i]*(Math.pow(10,-i*3));
	}
	
	if (release1_value > release2_value) return true;
	
	return false;
	
	/* wrong
	for (i=0;i<release1_numbers.length;i++){
		try {number_exists = release2_numbers[i];} catch (ex){return true;} // se non esiste il valore nella seconda...
		if (release1_numbers[i] > release2_numbers[i]) {return true;} else if (release1_numbers[i] < release2_numbers[i]) {return false;}
	}*/
}

function parseVersionPage()
{
	if (version_req_timeout) {version_req.abort(); version_req_timeout = false; version_req_stop_timeout = true; return;}
	
	if ((version_req.readyState == 4) && (version_req.status == 200)) {
		version_req_stop_timeout = true;
		version_req_timeout = false;
		
		latest_version = version_req.responseXML.getElementsByTagName("version");
		latest_version = latest_version[0].firstChild.data;
		
		// faccio una comparazione tra versioni
		if (isGreaterVersion(latest_version,current_version)){
			there_is_a_new_version = true;
		}
		
		/*
		if (latest_version != current_version){
			there_is_a_new_version = true;
		}*/
		//debug (latest_version);
		
		if (there_is_a_new_version) {
			new_version_badge.style.display = "block"
			new_version_tooltip_string = getLocalizedString('new_version_tooltip') + " " + latest_version + " (" + getLocalizedString('you_have') + " " + current_version + ")";
			new_version_badge.setAttribute ("title", new_version_tooltip_string);
		}
	}
}

function version_check()
{
	loadVersionPage('http://www.palple.net/widgets/tuttocitta/version.xml');
}